当前位置: 代码迷 >> 综合 >> Codeforces Round #149 (Div. 2) E. XOR on Segment(21棵线段树处理每一位+区间异或)
  详细解决方案

Codeforces Round #149 (Div. 2) E. XOR on Segment(21棵线段树处理每一位+区间异或)

热度:83   发布时间:2023-11-17 14:18:49.0

You've got an array a, consisting of n integers a1,?a2,?...,?an. You are allowed to perform two operations on this array:

  1. Calculate the sum of current array elements on the segment [l,?r], that is, count value al?+?al?+?1?+?...?+?ar.
  2. Apply the xor operation with a given number x to each array element on the segment [l,?r], that is, execute . This operation changes exactly r?-?l?+?1 array elements.

Expression  means applying bitwise xor operation to numbers x and y. The given operation exists in all modern programming languages, for example in language C++and Java it is marked as "^", in Pascal — as "xor".

You've got a list of m operations of the indicated type. Your task is to perform all given operations, for each sum query you should print the result you get.

Input

The first line contains integer n (1?≤?n?≤?105) — the size of the array. The second line contains space-separated integers a1,?a2,?...,?an (0?≤?ai?≤?106) — the original array.

The third line contains integer m (1?≤?m?≤?5·104) — the number of operations with the array. The i-th of the following m lines first contains an integer ti (1?≤?ti?≤?2) — the type of the i-th query. If ti?=?1, then this is the query of the sum, if ti?=?2, then this is the query to change array elements. If the i-th operation is of type 1, then next follow two integers li,?ri (1?≤?li?≤?ri?≤?n). If the i-th operation is of type 2, then next follow three integers li,?ri,?xi (1?≤?li?≤?ri?≤?n,?1?≤?xi?≤?106). The numbers on the lines are separated by single spaces.

Output

For each query of type 1 print in a single line the sum of numbers on the given segment. Print the answers to the queries in the order in which the queries go in the input.

Please, do not use the %lld specifier to read or write 64-bit integers in С++. It is preferred to use the cincout streams, or the %I64d specifier.

Example
Input
5
4 10 3 13 7
8
1 2 4
2 1 3 3
1 2 4
1 3 3
2 2 5 5
1 1 5
2 1 2 10
1 2 3
Output
26
22
0
34
11
Input
6
4 7 4 0 7 3
5
2 2 3 8
1 1 5
2 3 5 1
2 4 5 6
1 2 3
Output
38
28


题解:

题意:

给你一个序列,有两种操作,第一种是求[l,r]的和,第二种是将在[l,r]区间的每一个数异或上数x

思路:

一开始一个一个点去更新毫无疑问得在第16组数据tle了,然后没太多思路搜了下题解,说是21棵线段树。。。然后撸了3个小时才写出来

很有意思的一题:由于他给的数据范围转换成二进制最大是21位,所以我们用21棵线段树来保存数列中数字每一位的情况,第i棵数的[l,r]区间的v值代表着[l,r]的数字第i位的和,对于操作1,我们只要枚举21棵数,对于每一次询问第i棵数,答案ans+=(1<<i)*query[l,r]的值就是答案了,对于操作二,我们就把输入的数组x转化成二进制,对他的第i位去修改第i棵数在[l,r]上的值就好了,就是线段树的区间更新了,要用到lazy tag的思想,这题就解决了

代码:

#include<iostream>
#include<cstring>
#include<stdio.h>
#include<math.h>
#include<string>
#include<stdio.h>
#include<queue>
#include<stack>
#include<map>
#include<vector>
#include<deque>
#include<algorithm>
#define ll long long
#define INF 1008611111
#define M (t[i][k].l+t[i][k].r)/2
#define lson k*2
#define rson k*2+1
using namespace std;
struct node
{int l,r;int v;int tag;int length(){return r-l+1;}
}t[21][100005*4];
int b[100005][21];
void pushdown(int k,int i)
{if(t[i][k].tag%2){t[i][lson].tag++;t[i][rson].tag++;t[i][lson].v=t[i][lson].length()-t[i][lson].v;t[i][rson].v=t[i][rson].length()-t[i][rson].v;t[i][k].tag=0;}
}
void pushup(int k,int i)
{t[i][k].v=t[i][lson].v+t[i][rson].v;
}
void Build(int l,int r,int k,int i)
{t[i][k].l=l;t[i][k].r=r;t[i][k].tag=0;if(l==r){t[i][k].v=b[l][i];return;}int mid=M;Build(l,mid,lson,i);Build(mid+1,r,rson,i);pushup(k,i);
}
int query(int l,int r,int k,int i)
{if(t[i][k].l==l&&t[i][k].r==r){return t[i][k].v;}int mid=M;pushdown(k,i);if(r<=mid){return query(l,r,lson,i);}else if(l>mid){return query(l,r,rson,i);}else{int t1=query(l,mid,lson,i);int t2=query(mid+1,r,rson,i);return t1+t2;}
}
void update(int l,int r,int k,int i)
{if(t[i][k].l==l&&t[i][k].r==r){t[i][k].v=t[i][k].length()-t[i][k].v;t[i][k].tag++;return;}pushdown(k,i);int mid=M;if(r<=mid){update(l,r,lson,i);}else if(l>mid){update(l,r,rson,i);}else{update(l,mid,lson,i);update(mid+1,r,rson,i);}pushup(k,i);
}
int main()
{int i,j,n,m,d,x,y,v;while(scanf("%d",&n)!=EOF){for(i=1;i<=n;i++){scanf("%d",&x);j=0;while(x!=0){b[i][j]=x%2;x/=2;j++;}while(j<21){b[i][j]=0;j++;}}for(i=0;i<21;i++)Build(1,n,1,i);scanf("%d",&m);for(i=0;i<m;i++){scanf("%d",&d);if(d==1){scanf("%d%d",&x,&y);ll ans=0;for(j=0;j<21;j++){ans+=(ll)(1<<j)*query(x,y,1,j);//printf("ans=%d!\n",ans);}printf("%lld\n",ans);}else{scanf("%d%d%d",&x,&y,&v);j=0;while(v!=0){int temp=v%2;if(temp)update(x,y,1,j);j++;v/=2;}}}}return 0;
}


  相关解决方案